



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【ZOJ 3502】Contest</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【ZOJ 3502】Contest</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 13:13:00 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="http://acm.hust.edu.cn/vjudge/contest/view.action?cid=106593#problem/D" rel="external nofollow noreferrer">题</a></p>
<h2>题意</h2>
<p>　　n个问题，解决的顺序影响正确的概率，无论之前解决的问题是否答对，当前问题 j 答对概率为max{a[i][j]} (i为解决过的问题)。求答对题目的最大期望和对应的答题顺序。T组测试，<em>T</em>&nbsp;(0 &lt;&nbsp;<em>T</em>&nbsp;&le; 100)，&nbsp;<em>n</em>&nbsp;(0 &lt;&nbsp;<em>n</em>&nbsp;&le; 10)。</p>
<h2>分析</h2>
<p>　　n那么小，就想到状态压缩DP（我不会dfs做这题）</p>
<p>　　假设当前状态是 i ， i 对应的01串的1代表已经解决的问题，0代表尚未解决的，那么它肯定是由某个已解决的问题还没解决的状态转移过来的，也就是由其中一个1变为0的状态。所以我们枚举它里面的每个1，i&amp;(1&lt;&lt;l) ==1 表示第l个数字是1， j =&nbsp;i-(1&lt;&lt;l) 得到 j 状态。</p>
<p>　　dp表示状态i的期望，dp[i]=dp[j] + max(a[i][j]) 。因为多答出一题，期望就增加（1*答出这题的概率）。</p>
<p>　　同时每个状态用d储存答题顺序（期望最大且字典序最小的答题顺序）。</p>
<p>　　这句判断字典序：ex==dp[i] &amp;&amp; d[i]&gt;=d[i-(1&lt;&lt;l)]&nbsp;//如果新的dp[i-(1&lt;&lt;l)]的字典序比较小，dp[i]更新。因为一开始d都是0，所以要用&ge;，不然第一个样例就不会输出A。</p>
<p>　　注意如果计算的时候用浮点数，比较大小还要设置个精度。也可以直接储存整数，最后除以100化为 小数。</p>
<h2>代码</h2>
<div>
<pre class="prettyprint linenums">#include&lt;cstdio&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;iostream&gt;

using namespace std;

int t,n;<br />
int a[][];<br />
int dp[];<br />
string d[];

int main()<br />
{<br />
    scanf("%d",&amp;t);<br />
    while(t--)<br />
    {<br />
        scanf("%d",&amp;n);<br />
        for(int i=; i&lt;n; i++)<br />
            for(int j=; j&lt;n; j++)<br />
                scanf("%d",&amp;a[i][j]);<br />
        d[]="";<br />
        memset(dp,,sizeof(dp));<br />
        for(int i=; i&lt;(&lt;&lt;n); i++)<br />
            for(int l=; l&lt;n; l++)<br />
                if (i&amp;(&lt;&lt;l))// solve l<br />
                {<br />
                    int ex=;<br />
                    for(int u=; u&lt;n; u++)<br />
                    {<br />
                        if(i&amp;(&lt;&lt;u) &amp;&amp; a[u][l]&gt;ex)//u have been solved<br />
                        {<br />
                            ex=a[u][l];<br />
                        }<br />
                    }<br />
                    ex+=dp[i-(&lt;&lt;l)];<br />
                    char now='A'+l;//第l个问题的字母表示<br />
                    if(ex&gt;dp[i] || ex==dp[i] &amp;&amp; d[i]&gt;=d[i-(&lt;&lt;l)])<br />
                    {<br />
                        d[i]=d[i-(&lt;&lt;l)]+now;<br />
                        dp[i]=ex;<br />
                    }<br />
                }<br />
        double ans=dp[(&lt;&lt;n) - ]*1.0/;

        printf("%.2lf\n",ans);<br />
        cout&lt;&lt;d[(&lt;&lt;n) - ]&lt;&lt;endl;<br />
    }<br />
    return ;<br />
}</pre>
</div>
<p>　　</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qn560jq.html">JS常用正则表达式和JS控制输入框输入限制&lpar;数字、汉字、字符&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96w3rvq.html">python的基础类源码解析&mdash;&mdash;collection类</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx0w1eq.html">针对特定浏览器起作用的CSS&colon; IE Chrome Firefox CSS Hack</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okn4n19.html">PHP V5&period;2 中的新增功能，第 1 部分&colon; 使用新的内存管理器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjnr7k9.html">2016年11月24日 星期四 --出埃及记 Exodus 20&colon;15</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yy0o0q.html">获取IE代理服务器信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn50mj8.html">codevs 1106 篝火晚会</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vy2j38.html">动态 SQL</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd6logq.html">C&num; 实现HTML5服务器推送事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv44lyq.html">Hook linux 网络封包</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mpe3jq.html">赵雅智&lowbar;BroadcastReceiver</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ynkmz8.html">Javascript：面试经典套路-查重（reduce）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge7ek48.html">Java API获取topic所占磁盘空间&lpar;Kafka 1&period;0&period;0&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj3jpg8.html">H5网页后在返回到微信公众平台自定义菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdeydz9.html">Java的动手动脑（五）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m27dwrq.html">大话设计模式C&plus;&plus;  适配器模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/963jgoj9.html">kali2&period;0 使用SSH进行远程登录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjrx628.html">提高JetBrains软件的性能</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o420ppq.html">20165230 2017-2018-2 《Java程序设计》第8周学习总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7eyd5e9.html">Building Your First App（创建你的第一个应用程序）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/r93eo50q.html">vector中pair的排序方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qymdxxq.html">IL查看泛型</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ky1e69.html">HTML5之应用缓存---manifest---缓存使用----HTML5的manifest缓存</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m32d69.html">Ember模板中的操作指向</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8kyoj79.html">关于第一个Java应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zdk2x9.html">WPF RadioButton 转换</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qym262q.html">&lbrack;转&rsqb;Ubuntu 用vsftpd 配置FTP服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m3dr09.html">客户端缓存&lpar;Client Cache&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ozdee9.html">Summary Ranges</a>
			</li>
						<li><a href="https://www.batexi.com/a/390zeyjq.html">Git初级使用教程&lpar;转&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
